ERR_get_error(3)

NAME
ERR_get_error, ERR_peek_error - obtain error code

LIBRARY
libcrypto, -lcrypto

SYNOPSIS

 #include <openssl/err.h>
 unsigned long ERR_get_error(void);
 unsigned long ERR_peek_error(void);
 unsigned long ERR_get_error_line(const char **file, int *line);
 unsigned long ERR_peek_error_line(const char **file, int *line);
 unsigned long ERR_get_error_line_data(const char **file, int *line,
         const char **data, int *flags);
 unsigned long ERR_peek_error_line_data(const char **file, int *line,
         const char **data, int *flags);

DESCRIPTION
ERR_get_error() returns the last error code from the thread's error queue and removes the entry. This function can be called repeatedly until there are no more error codes to return.

ERR_peek_error() returns the last error code from the thread's error queue without modifying it.

See the ERR_GET_LIB(3)|ERR_GET_LIB(3) manpage for obtaining information about location and reason of the error, and the ERR_error_string(3)|ERR_error_string(3) manpage for human-readable error messages.

ERR_get_error_line() and ERR_peek_error_line() are the same as the above, but they additionally store the file name and line number where the error occurred in *file and *line, unless these are NULL.

ERR_get_error_line_data() and ERR_peek_error_line_data() store additional data and flags associated with the error code in *data and *flags, unless these are NULL. *data contains a string if *flags&ERR_TXT_STRING. If it has been allocated by Malloc(), *flags&ERR_TXT_MALLOCED is true.

RETURN VALUES
The error code, or 0 if there is no error in the queue.

SEE ALSO
the err(3)|err(3) manpage, the ERR_error_string(3)|ERR_error_string(3) manpage, the ERR_GET_LIB(3)|ERR_GET_LIB(3) manpage

HISTORY
ERR_get_error(), ERR_peek_error(), ERR_get_error_line() and ERR_peek_error_line() are available in all versions of SSLeay and OpenSSL. ERR_get_error_line_data() and ERR_peek_error_line_data() were added in SSLeay 0.9.0.